# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define section free

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

Name: ecj
Epoch: 0
Version: 3.3.1.1
Release: 4.9
Summary: Eclipse Compiler for Java

Group: Development/Languages
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
License: EPL
URL: http://www.eclipse.org
# this tarball is generated by a script that uses the original eclipse sources
# script is included for documentation purposes in the docdir of the package
Source0: %{name}-%{version}.tar.gz
# this is the changelog from the original JPackage eclipse package that is
# included for documentation and recognition purposes only
Source1: eclipse-jpackage-changelog.txt
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
%if ! %{gcj_support}
BuildArch: noarch
%endif

BuildRequires: ant
BuildRequires: jpackage-utils >= 0:1.7
%if %{gcj_support}
BuildRequires: gcc-java >= 4.0.0
Requires: libgcj >= 4.0.0
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%else
BuildRequires: java-sun
# autobuild stuff only, could be removed for upstream
%if %defined suse_version
BuildRequires:  sed
%else
BuildRequires: %{__sed}
%endif
Requires: java-sun-jre
%endif
%if %defined suse_version
BuildRequires:  unzip
%endif


%description
Eclipse Compiler for Java

%prep
%setup -q

%build
%{__cp} %{SOURCE1} .
unset CLASSPATH
%if %{gcj_support}
    for f in `find -name '*.java'`; do
        gcj -Wno-deprecated -C $f
    done
    find . \( -name '*.class' -o -name '*.properties' -o -name '*.rsc' \) \
        | xargs jar cf %{name}-%{version}.jar
%else
    # remove -Xlint:none from javac compiler arguments as it causes
    # Sun Java 1.4.2 to crap out
    %{__sed} -i -e 's,-Xlint:none ,,g' jdtcoresrc/compilejdtcorewithjavac.xml
    # first invocation builds with javac, second time around with ecj itself
    ant -f jdtcoresrc/compilejdtcorewithjavac.xml
    CLASSPATH="`pwd`/jdtcoresrc/%{name}.jar" \
        ant -f jdtcoresrc/compilejdtcore.xml
    # just to make sure there is no confusion, delete the bootstrap ecj jar
    %{__rm} jdtcoresrc/%{name}.jar
%endif

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}
%{__install} -m 0644 %{name}.jar \
    ${RPM_BUILD_ROOT}%{_javadir}/%{name}-%{version}.jar
cd ${RPM_BUILD_ROOT}%{_javadir}
    %{__ln_s} %{name}-%{version}.jar %{name}.jar
cd ${RPM_BUILD_ROOT}
%if %{gcj_support}
    aot-compile-rpm
%endif

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post
if [ -x "%{_bindir}/rebuild-gcj-db" ]; then
    %{_bindir}/rebuild-gcj-db
fi

%postun
if [ -x "%{_bindir}/rebuild-gcj-db" ]; then
    %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%doc eclipse-jpackage-changelog.txt %{name}-tarballBuild.sh
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%if %{gcj_support}
%{_libdir}/gcj/%{name}
%endif

%changelog
* Fri Oct 26 2007 Jason Corley <jason.corley@gmail.com> - 0:3.3.1.1-1jpp
- update to 3.3.1.1

* Fri Mar 23 2007 Jason Corley <jason.corley@gmail.com> - 0:3.3-1jpp
- update to 3.3
- add R on java and BR on sed

* Fri Mar 23 2007 Jason Corley <jason.corley@gmail.com> - 0:3.2.2-3jpp
- remove jdtcore link

* Mon Mar 12 2007 Jason Corley <jason.corley@gmail.com> - 0:3.2.2-2jpp
- rename to just ecj
- add gcj compilation switches (Andrew Overholt)

* Fri Mar  2 2007 Jason Corley <jason.corley@gmail.com> - 0:3.2.2-1jpp
- first attempt at a noarch ecj only package

